from selenium.webdriver.support.wait import WebDriverWait
import time
import re

class HumanAd:
    def __init__(self, driver):
        self.driver = driver
        self.name_set = set()  # 存储固有的name

    def get_human_info(self, name_set_local):
        names = self.driver.find_elements_by_class_name('adui-table-cellInner')

        for name in names:
            name_set_local.add(name.text)

    def check_human_info(self):
        # 处理玩完之后回到概览页面
        # 检查人群数据包是否相同
        self.driver.find_element_by_id('dmp').click()
        WebDriverWait(self.driver, 100).until(lambda driver: driver.find_element_by_class_name(
            'adui-pagination-text'))
        page_info = self.driver.find_element_by_class_name('adui-pagination-text').text
        nums = re.split('/', page_info)
        name_set_local = set()
        self.get_human_info(name_set_local)
        for i in range(int(nums[1].strip())-int(nums[0].strip())):
            self.driver.find_element_by_css_selector(
                '#wxadcontainer > section > div.weui-desktop-layout__main__bd > div > div.adui-pagination-base.adui-pagination-small.adui-pagination-right > button:nth-child(4)').click()
            time.sleep(1)
            self.get_human_info(name_set_local)

        # 切回正常页面
        self.driver.find_element_by_id('overview').click()


if __name__ == "__main__":
    pass
